#include <SPI.h>
#include <SD.h>

const int chipSelect = 4;
float pressure = 0;
float temperature = 2;
float altitude = 1;
float positionB = 3;
float timeB = 4; 

void setup()
{
  //pinMode(valvePin1, OUTPUT);
  //pinMode(valvePin2, OUTPUT);

  
  // Open serial communications and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for Leonardo only
  }

  Serial.print("Initializing SD card...");

  // see if the card is present and can be initialized:
  if (!SD.begin()) {
    Serial.println("Card failed, or not present");
    // don't do anything more:
    return;
  }
  Serial.println("card initialized.");
}

void loop()
{
  writeLogHeader();
  while(pressure < 10)
  {
      pressure++;
      while(altitude < 11)
      {
          altitude++;
          while(temperature < 12)
          {
              temperature++;
              while(positionB < 13)
              {
                    positionB++;
                    while(timeB < 14)
                    {
                        timeB++;
                        writeLog(pressure, altitude, temperature, positionB, timeB);
                    }
                    writeLog(pressure, altitude, temperature, positionB, timeB);
              }
              writeLog(pressure, altitude, temperature, positionB, timeB);
          }
          writeLog(pressure, altitude, temperature, positionB, timeB);
      }
      writeLog(pressure, altitude, temperature, positionB, timeB);
  }

}

/*double getPressure(){
  //Joesph
}
double getAltitude(){
  //Joesph
}
double getTemperature(){
  //Joesph
}

void openValve(){
  //digitalWrite(valvePin1, HIGH);
}
void closeValve{
  //digitalWrite(valvePin2, HIGH);
}

double getAltitudeGPS(){
  //Eric
}
double getPosition(){
  //Eric
}
double getTime(){
  //Eric
}*/

void writeLogHeader()
{
    File dataFile = SD.open("datalog.txt", FILE_WRITE);

  // if the file is available, write to it:
  if (dataFile) {
    dataFile.println("Pressure,   Altitude,   Temperature,    Position,   Time    ");
  }
  else {
    Serial.println("error opening datalog.txt");
  }
  
}

void writeLog(float p, float a, float t, float pB, float tB){
    // make a string for assembling the data to log:
  String dataString = "";
  dataString += p; 
  dataString += ",      ";
  dataString += a;
  dataString += ",      ";
  dataString += t;
  dataString += ",      ";
  dataString += pB; 
  dataString += ",      ";
  dataString += tB;

  // open the file. note that only one file can be open at a time,
  // so you have to close this one before opening another.
  File dataFile = SD.open("datalog.txt", FILE_WRITE);

  // if the file is available, write to it:
  if (dataFile) {
    dataFile.println(dataString);
    dataFile.close();
    // print to the serial port too:
    Serial.println(dataString);
  }
  // if the file isn't open, pop up an error:
  else {
    Serial.println("error opening datalog.txt");
  }
}

